﻿/* 
 * Copyright (c)2009-2019 DemiVision, LLC. All Rights Reserved. The information 
 * herein is the CONFIDENTIAL and PROPRIETARY information of DemiVision, LLC. 
 */

using Xamarin.Forms;

using Syncfusion.SfDataGrid.XForms;

//using DXLib.UI;
//using DXLib.Utils;

namespace iStatPractice
{
    /*
	 * Provides custom styling for SfDataGrid.
	 */
    public class GridStyle : DataGridStyle
    {
        /* Lines, Borders */

        public override GridLinesVisibility GetGridLinesVisibility()
        {
            return GridLinesVisibility.Both;
        }

        public override float GetHeaderBorderWidth()
        {
            return 1;
        }

        public override float GetBorderWidth()
        {
            return 1;
        }

        //public override Color GetResizingIndicatorColor()
        //{
        //    return DXStyle.Action;
        //}

        /* Icons */

        public override ImageSource GetHeaderSortIndicatorDown()
        {
            // Null makes arrow animate between up/down
            return null;
        }

        //public override ImageSource GetHeaderSortIndicatorUp()
        //{
        //	string path = $"{DXResource.Path}.Images.arrow_up.png";

        //	return ImageSource.FromResource( path );
        //}

        /* Colors */

        // Borders
        //public override Color GetBorderColor()
        //{
        //	return DXStyle.Dark3;
        //}

        //// Header
        //public override Color GetHeaderBackgroundColor()
        //{
        //	return DXStyle.Accent1;
        //}

        //public override Color GetHeaderForegroundColor()
        //{
        //	return DXStyle.Dark1;
        //}

        // Cells
        //public override Color GetRecordBackgroundColor()
        //{
        //	return DXStyle.Light3;
        //}

        public override Color GetAlternatingRowBackgroundColor()
        {
            return Color.LightBlue;
        }

        //public override Color GetRecordForegroundColor()
        //{
        //	return DXStyle.Dark1;
        //}

        /* Total Row */

        //public override Color GetUnboundRowForegroundColor()
        //{
        //	return DXStyle.Dark1;
        //}

        public override Color GetUnboundRowBackgroundColor()
        {
            return Color.Pink;
        }

        public override FontAttributes GetUnboundRowFontAttribute()
        {
            return FontAttributes.Bold;
        }
    }
}

//
