﻿///* 
// * Copyright (c)2009-2019 DemiVision, LLC. All Rights Reserved. The information 
// * herein is the CONFIDENTIAL and PROPRIETARY information of DemiVision, LLC. 
// */

//using System.Linq;
//using System.Collections.Generic;

//using Xamarin.Forms;

//using Syncfusion.Data;
//using Syncfusion.SfDataGrid.XForms;

////using DXLib.UI;
////using DXLib.Data;
////using DXLib.Utils;

//namespace iStatPractice
//{
//	/*
//	 * Base class for all metric plugin report grids. Performs query calculations 
//	 * and grid setup common to all plugin types.
//	 */
//	public abstract class PluginGrid : SfDataGrid
//	{
//		/* Constants */
//		private const double RowHt = 35;

//		/* Fields */
//		//protected PluginData totalRow;
//		//protected Metric metric;

//		//List<Player> players;
//		//List<Stat> stats;

//		readonly Thickness cellPadding;
//		protected string totalStr;

//		/* Methods */
//		protected PluginGrid()
//		{
//			BackgroundColor = DXStyle.Light3;

//			cellPadding = DXDevice.IsTablet() ? new Thickness( 10, 5 ) : new Thickness( 5, 5 );
//			totalStr = DXString.GetUpper( "grid.total" );

//			// Custom styling
//			GridStyle = new GridStyle();

//			// Custom total row
//			var unboundRow = new GridUnboundRow
//			{
//				Position = UnboundRowsPosition.FixedBottom
//			};

//			UnboundRows.Add( unboundRow );

//			// Columns auto fit to content
//			AutoGenerateColumns = false;
//			ColumnSizer = ColumnSizer.Auto;

//			// Fixed row height, alternating row colors
//			ShowRowHeader = false;
//			HeaderRowHeight = RowHt;
//			RowHeight = RowHt;
//			AlternationCount = 2;

//			// Scrolling behavior
//			ScrollingMode = ScrollingMode.Pixel;
//			VerticalOverScrollMode = VerticalOverScrollMode.None;
//			FrozenColumnsCount = 1;

//			// Resizing ON
//			AllowResizingColumn = true;
//			ResizingMode = ResizingMode.OnMoved;

//			// Sorting ON, one column at a time
//			AllowSorting = true;
//			AllowMultiSorting = false;
//			AllowTriStateSorting = false;

//			// Editing, gestures, selection OFF
//			AllowEditing = false;
//			AllowDraggingRow = false;
//			AllowDraggingColumn = false;
//			AllowSwiping = false;

//			SelectionMode = SelectionMode.None;

//			// Last row/col customization
//			QueryCellStyle += CustomizeCells;
//			QueryUnboundRow += PopulateTotals;

//			// Do NOT expand vertically
//			HorizontalOptions = LayoutOptions.FillAndExpand;
//			VerticalOptions = LayoutOptions.Start;
//		}

//		// Must be called by parent view after creation
//		public void Init( AnalyzeData data )
//		{
//			this.metric = data.Metric;
//			this.players = data.Players.ToList();
//			this.stats = data.Stats;

//			// Dynamically size to contents
//			HeightRequest = (players.Count + 2) * RowHt;
//			WidthRequest = DXDevice.NormalizedWd();

//			// Run query, setup grid
//			Calculate();
//			Format();
//		}

//		// Must be implmented by subclass to return metric specific column count
//		protected abstract int GetColumnCount();

//		// Must be implemented by subclass to return metric specific data instance
//		protected abstract PluginData CreateRow();

//		// Must be implemented by subclass to process metric specific query results
//		protected abstract void CalculateRow( Stat stat, PluginData data );

//		// Must be implemented by subclass to populate custom unbound total row
//		protected abstract object PopulateTotals( int column );

//		// Populates grid with data
//		void Calculate()
//		{
//			var data = new List<PluginData>();

//			// Custom unbound row
//			totalRow = CreateRow();

//			// Calculate all player rows
//			foreach ( Player player in players )
//			{
//				var row = CreateRow();

//				// First column always player name
//				row.Player = player;
//				row.Label = player.FullName;

//				data.Add( row );

//				// For each stat, for each player, accumulate values for the metric
//				foreach ( Stat stat in stats )
//				{
//					if ( stat.Player.Equals( player ) )
//					{
//						if ( stat.Metric.Equals( metric ) )
//						{
//							CalculateRow( stat, row );
//						}
//					}
//				}
//			}

//			// Populate grid
//			ItemsSource = data;
//		}

//		// Should be extended by subclass to setup metric specific grid
//		protected virtual void Format()
//		{
//			// All player grids have player as first column
//			var playerCol = new GridTextColumn
//			{
//				MappingName = "Label",
//				MinimumWidth = 150,
//				HeaderText = DXString.GetUpper( "grid.player" )
//			};

//			StyleFirstColumn( playerCol );
//			Add( playerCol );

//			// Default sort on player column
//			SortColumnDescriptions.Add( new SortColumnDescription()
//			{
//				ColumnName = "Label",
//				SortDirection = ListSortDirection.Ascending
//			});
//		}

//		// Shorthand for adding column to grid
//		protected void Add( GridColumn item )
//		{
//			Columns.Add( item );
//		}

//		// Populates custom unbound total row
//		void PopulateTotals( object sender, GridUnboundRowEventArgs args )
//		{
//			args.Value = PopulateTotals( args.RowColumnIndex.ColumnIndex );
//			args.Handled = true;
//		}

//		// Customizes style for last row/column
//		void CustomizeCells( object sender, QueryCellStyleEventArgs args )
//		{
//			bool lastRow = args.RowIndex == (players.Count + 1);
//			bool lastColumn = args.ColumnIndex == (GetColumnCount() - 1);

//			// TEMP: Unbound total row bgnd color must be set here
//			if ( lastRow )
//			{
//			//	args.Style.BackgroundColor = DXStyle.Accent1;
//			}
//			// Last column highligted
//			else if ( lastColumn )
//			{
//				args.Style.BackgroundColor = DXStyle.Accent2;
//				args.Style.FontAttribute = FontAttributes.Bold;
//			}

//			args.Handled = true;
//		}

//		// Applies custom styling to first column
//		protected void StyleFirstColumn( GridColumn column )
//		{
//			StyleHeader( column, true );
//			StyleCells( column, true );
//		}

//		// Applies custom styling for any middle column
//		protected void StyleColumn( GridColumn column )
//		{
//			StyleHeader( column, false );
//			StyleCells( column, false );
//		}

//		// Applies custom styling to a header cell
//		protected void StyleHeader( GridColumn column, bool first )
//		{
//			column.HeaderFont = "Roboto";
//			column.HeaderFontAttribute = FontAttributes.Bold;
//			column.HeaderCellTextSize = 14;

//			column.HeaderTextAlignment = (first ? TextAlignment.Start : TextAlignment.Center);

//			column.LineBreakMode = LineBreakMode.NoWrap;
//			column.Padding = cellPadding;
//		}

//		// Applies custom styling to any non-header cell
//		protected void StyleCells( GridColumn column, bool first )
//		{
//			column.RecordFont = "Roboto";
//			column.FontAttribute = FontAttributes.None;
//			column.CellTextSize = 14;

//			column.TextAlignment = (first ? TextAlignment.Start : TextAlignment.Center);

//			column.LineBreakMode = LineBreakMode.NoWrap;
//			column.Padding = cellPadding;
//		}
//	}
//}

////
